/*  cmos.h                                                      (CRC:90bcf056)
 *      relative path: ./I386
 *      creation date: 1992
 *      last modified: Wed Dec 18 07:15:47 1996
 *      header update: Wed Dec 18 07:15:47 1996
 *  
 *       Intel 386 PC  machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __CMOS_H__
#define __CMOS_H__

#define WAT_SEC		0
#define WAT_ALMS	1
#define WAT_MIN		2
#define WAT_ALMM	3
#define WAT_HOUR	4
#define WAT_ALMH	5
#define WAT_DOW		6
#define WAT_DAY		7
#define WAT_MON		8
#define WAT_YEAR	9
#define WAT_CSRA	10
#define WAT_CSRB	11
#define WAT_CSRC	12
#define WAT_CSRD	13
#define WAT_CENTURY	0x32

#define CMOS_DIAG	0xe
#define CMOS_SHUTDOWN	0xf
#define CMOS_FDTYPE	0x10
#define CMOS_HDTYPE	0x12
#define CMOS_EQBYTE	0x14
#define	CMOS_BASEMEMLO	0x15
#define CMOS_BASEMEMHI	0x16
#define CMOS_EXTMEMLO	0x17
#define CMOS_EXTMEMHI	0x18
#define CMOS_HDTYPE0	0x19
#define CMOS_HDTYPE1	0x1a
#define CMOS_POSTMEMLO	0x30
#define CMOS_POSTMEMHI	0x31

#endif /* __CMOS_H__ */

