/*  keyboard.h                                                  (CRC:c389f1b1)
 *      relative path: ./I386
 *      creation date: 1992
 *      last modified: Wed Dec 18 07:15:52 1996
 *      header update: Wed Dec 18 07:15:52 1996
 *  
 *       Intel 386 PC  machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __KEYBOARD_H__
#define __KEYBOARD_H__

#define KEY_ESC		0x01
#define KEY_F1		0x3b
#define KEY_F2		0x3c
#define KEY_F3		0x3d
#define KEY_F4		0x3e
#define KEY_F5		0x3f
#define KEY_F6		0x40
#define KEY_F7		0x41
#define KEY_F8		0x42
#define KEY_F9		0x43
#define KEY_F10		0x44
#define KEY_F11		0x57
#define KEY_F12		0x58
#define KEY_SYS_REQ	(0x80|0x2a)
#define KEY_PRT_SCR	(0x80|0x37)
#define KEY_SCRL_LOCK	0x46
#define KEY_PAUSE	(0x80|0x7f)
#define KEY_BACKSPACE	0x0e
#define KEY_ENTER	0x1c
#define KEY_TAB		0x0f
#define KEY_SPACE	0x39
#define KEY_CAPS_LOCK	0x3a
#define KEY_LSHIFT	0x2a
#define KEY_RSHIFT	0x36
#define KEY_LCTRL	0x1d
#define KEY_RCTRL	(0x80|0x1d)
#define KEY_LALT	0x38
#define KEY_RALT	(0x80|0x38)
#define KEY_INSERT	(0x80|0x52)
#define KEY_DELETE	(0x80|0x53)
#define KEY_HOME	(0x80|0x47)
#define KEY_END		(0x80|0x4f)
#define KEY_PAGE_UP	85
#define KEY_PAGE_DOWN	86
#define KEY_UP		83
#define KEY_DOWN	84
#define KEY_RIGHT	89
#define KEY_LEFT	79
#define KEY_NUM_LOCK	0x45
#define KEY_KP_SLASH	95
#define KEY_KP_STAR	100
#define KEY_KP_DASH	105
#define KEY_KP_7	91
#define KEY_KP_8	96
#define KEY_KP_9	101
#define KEY_KP_4	92
#define KEY_KP_5	97
#define KEY_KP_6	102
#define KEY_KP_1	93
#define KEY_KP_2	98
#define KEY_KP_3	103
#define KEY_KP_0	99
#define KEY_KP_DOT	104
#define KEY_KP_PLUS	106
#define KEY_KP_ENTER	108
#define KEY_1		0x02
#define KEY_2		0x03
#define KEY_3		0x04
#define KEY_4		0x05
#define KEY_5		0x06
#define KEY_6		0x07
#define KEY_7		0x08
#define KEY_8		0x09
#define KEY_9		0x0a
#define KEY_0		0x0b
#define KEY_MINUS	0x0c
#define KEY_EQUAL	0x0d
#define KEY_Q		0x10
#define KEY_W		0x11
#define KEY_E		0x12
#define KEY_R		0x13
#define KEY_T		0x14
#define KEY_Y		0x15
#define KEY_U		0x16
#define KEY_I		0x17
#define	KEY_O		0x18
#define KEY_P		0x19
#define KEY_LBRACKET	0x1a
#define KEY_RBRACKET	0x1b
#define KEY_A		0x1e
#define KEY_S		0x1f
#define KEY_D		0x20
#define KEY_F		0x21
#define KEY_G		0x22
#define KEY_H		0x23
#define KEY_J		0x24
#define KEY_K		0x25
#define KEY_L		0x26
#define KEY_SEMICOLON	0x27
#define KEY_QUOTE	0x28
#define KEY_TILDE	0x29
#define KEY_BACKSLASH	0x2a
#define KEY_Z		0x2c
#define KEY_X		0x2d
#define KEY_C		0x2e
#define KEY_V		0x2f
#define KEY_B		0x30
#define KEY_N		0x31
#define KEY_M		0x32
#define KEY_COMMA	0x33
#define KEY_PERIOD	0x34
#define KEY_SLASH	0x35
#define KEY_NONE	(0x80|0x7f)
#define KEY_CAPS_LOCKED (0x80|0x7e)
#define KEY_NUM_LOCKED	(0x80|0x7d)
#define KEY_SCRL_LOCKED (0x80|0x7c)

#endif /* __KEYBOARD_H__ */

