/*  port.h                                                      (CRC:9a82cf8e)
 *      relative path: ./I386
 *      creation date: 1992
 *      last modified: Wed Dec 18 07:16:05 1996
 *      header update: Wed Dec 18 07:16:05 1996
 *  
 *       Intel 386 PC  machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __PORT_H__
#define __PORT_H__


/*** I/O ports ***/

/* Direct Memory Access: */
#define DMA_ADR0	0x00
#define DMA_WCOUNT0	0x01
#define DMA_ADR1	0x02
#define DMA_WCOUNT1	0x03
#define DMA_ADR2	0x04
#define DMA_WCOUNT2	0x05
#define DMA_ADR3	0x06
#define DMA_WCOUNT3	0x07
#define DMA_STATUS	0x08
#define DMA_CMD		0x08
#define DMA_WRITE	0x09
#define DMA_MASK	0x0a
#define	DMA_MODE	0x0b
#define DMA_CLEAR	0x0c
#define DMA_RESET	0x0d
#define DMA_CMASK	0x0e
#define DMA_WMASK	0x0f

/* Programmable Interrupt Controller: */
#define PIC1_OCW1	0x21
#define PIC1_OCW2	0x20
#define PIC1_OCW3	0x20
#define PIC1_ICW1	0x20
#define PIC1_ICW2	0x21
#define PIC1_ICW3	0x21
#define PIC1_ICW4	0x21

#define PIC2_OCW1	0xa1
#define PIC2_OCW2	0xa0
#define PIC2_OCW3	0xa0
#define PIC2_ICW1	0xa0
#define PIC2_ICW2	0xa1
#define PIC2_ICW3	0xa1
#define PIC2_ICW4	0xa1

/* Programmable Interrupt Timer: */
#define PIT_CHAN0	0x40
#define PIT_CHAN1	0x41
#define PIT_CHAN2	0x42
#define PIT_MODE	0x43
#define PIT_CTRL	0x47

/* keyboard: */
#define	KB_DATA		0x60		/* kbd data port */ 
#define KB_PORTB	0x61		/* speaker/etc */
#define	KB_STATUS	0x64		/* kbd status port */ 
#define	 KB_STAT_RDY	0x02		/* kbd char ready */ 

/* CMOS: */
#define CMOS_INDEX	0x70
#define CMOS_DATA	0x71

#endif /* __PORT_H__ */

