/*  context.h                                                   (CRC:a6089719)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Wed May 22 21:28:01 1996
 *      header update: Wed Dec 18 07:16:21 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __CONTEXT_H__
#define __CONTEXT_H__


#ifndef ASM

typedef struct {
        vaddr   ksp;	  /* kernel stack pointer */
        vaddr   esp;
        vaddr   ssp;
        vaddr   usp;	  /* user stack pointer */
        ulong   reg[12];  /* 12 general registers */
        ulong   ap;	  /* argument pointer */
        ulong   fp;	  /* frame pointer */
        ulong   pc;	  /* program counter */
        ulong   psl;	  /* processor status longword */
        ulong   p0br;	  /* P0 (user) base register */
        unsigned p0lr:22; /* P0 length register */
	unsigned resv1:2;
        unsigned astlvl:3;/* Asynchronous System Trap level */
        unsigned resv2:5; 
        ulong   p1br;	  /* P1 (stack) base register */
        unsigned p1lr:22; /* P1 length register */
        unsigned resv3:9;
        unsigned pme:1;	  /* Performance monitor enable */
	paddr	pcbb;	  /* physical address of context data structure */
} Context;


#endif

/* offsets for accessing context from assembly: */
#define CONTEXT_PC	72
#define CONTEXT_KSP	0
#define CONTEXT_USP	12
#define CONTEXT_PCBB	96

#endif /* __CONTEXT_H__ */

