/*  keyboard.h                                                  (CRC:37de9b75)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Wed May 22 21:28:05 1996
 *      header update: Wed Dec 18 07:16:23 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __KEYBOARD_H__
#define __KEYBOARD_H__

/* LK201 Keyboard Definitions */

#define KEY_F1			 86
#define KEY_F2			 87
#define KEY_F3			 88
#define KEY_F4			 89
#define KEY_F5			 90
#define KEY_F6			100
#define KEY_F7			101
#define KEY_F8			102
#define KEY_F9			103
#define KEY_F10			104
#define KEY_F11			113
#define KEY_F12			114
#define KEY_F13			115
#define KEY_F14			116
#define KEY_F15  		124
#define KEY_F16 		125
#define KEY_F17			128
#define KEY_F18			129
#define KEY_F19			130
#define KEY_F20			131
#define KEY_FIND		138
#define KEY_INSERT_HERE		139
#define KEY_REMOVE		140
#define KEY_SELECT		141
#define KEY_PREV_SCREEN		142 
#define KEY_NEXT_SCREEN		143
#define KEY_KP_0		146	/* key pad */
#define KEY_KP_PERIOD		148	/* key pad */
#define KEY_KP_ENTER		149	/* key pad */
#define KEY_KP_1		150	/* key pad */
#define KEY_KP_2		151	/* key pad */
#define KEY_KP_3		152	/* key pad */
#define KEY_KP_4		153	/* key pad */
#define KEY_KP_5		154	/* key pad */
#define KEY_KP_6		155	/* key pad */
#define KEY_KP_COMMA		156	/* key pad */
#define KEY_KP_7		157	/* key pad */
#define KEY_KP_8		158	/* key pad */
#define KEY_KP_9		159	/* key pad */
#define KEY_KP_HYPHEN		160
#define KEY_KP_PF1		161
#define KEY_KP_PF2		162
#define KEY_KP_PF3		163
#define KEY_KP_PF4		164
#define KEY_LEFT		167
#define KEY_RIGHT		168
#define KEY_DOWN		169
#define KEY_UP			170
#define KEY_SHIFT		174
#define KEY_CTRL		175
#define KEY_LOCK		176
#define KEY_COMPOSE		177
#define KEY_RELEASE		179
#define KEY_REPEAT		180
#define KEY_DELETE		188
#define KEY_RETURN		189
#define KEY_TAB			190
#define KEY_TILDE		191
#define KEY_TR_1		192	/* Top Row */
#define KEY_Q			193
#define KEY_A			194
#define KEY_Z			195
#define KEY_TR_2		197
#define KEY_W			198
#define KEY_S			199
#define KEY_X			200
#define KEY_LANGLE_RANGLE	201	/* xxx */
#define KEY_TR_3		203
#define KEY_E			204
#define KEY_D			205
#define KEY_C			206
#define KEY_TR_4		208
#define KEY_R			209
#define KEY_F			210
#define KEY_V			211
#define KEY_SPACE		212
#define KEY_TR_5		214
#define KEY_T			215
#define KEY_G			216
#define KEY_B			217
#define KEY_TR_6		219
#define KEY_Y			220
#define KEY_H			221
#define KEY_N			222
#define KEY_TR_7		224
#define KEY_U			225
#define KEY_J			226
#define KEY_M			227
#define KEY_TR_8		229
#define KEY_I			230
#define KEY_K			231
#define KEY_COMMA		232	/* xxx */
#define KEY_TR_9		234
#define KEY_O			235
#define KEY_L			236
#define KEY_PERIOD		237	/* xxx */
#define KEY_TR_0		239
#define KEY_P			240
#define KEY_SEMICOLON		242	/* xxx */
#define KEY_QMARK		243
#define KEY_PLUS		245	/* xxx */
#define KEY_RBRACE		246
#define KEY_VBAR		247	/* xxx */
#define KEY_UBAR		249	/* xxx */
#define KEY_LBRACE		250
#define KEY_QUOTE		251

#endif /* __KEYBOARD_H__ */

