/*  mdvct.c                                                     (CRC:c2fba8a1)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Thu Dec 19 18:19:55 1996
 *      header update: Fri Dec 20 09:08:43 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* mdvct.c
 *   driver for basic vt100 console I/O
 *   I386 machine dependent part
 *   to be included from drv/vct.c
 */

#include <stdio.h>


extern label_t _rnoblock, _wnoblock;
extern label_t _stdin, _stdout, _stderr;
extern label_t _wid, _hgt;
extern label_t _reboot, _halt;
extern label_t _msleep;


#define VT_SET_CURSOR(vt,x,y) 

static struct vt_state vtstate;


obj_t Main(ObjFrame *frame, vaddr base, obj_t arg, obj_t env)
{
	cprintf("Virtual Console Terminal (vct) v0.10  Nov 1992\n");
	vt_init(&vtstate);
	vt_write(&vtstate,0,0);
	return(OK);
}


#define VT_PUTCHAR(vt,x,y,ch)		
#define VT_SCROLL_UP(vt,x1,y1,x2,y2,n)    
#define VT_SCROLL_DOWN(vt,x1,y1,x2,y2,n)  
#define VT_SCROLL_RIGHT(vt,x1,y1,x2,y2,n) 
#define VT_SCROLL_LEFT(vt,x1,y1,x2,y2,n)  
#define VT_CLEAR(vt,x1,y1,x2,y2)	  

#define VT_SET_COLOR(vt)		
#define VT_BEEP(vt)			



