/*  mvax.h                                                      (CRC:305f40e2)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Wed May 22 21:28:12 1996
 *      header update: Wed Dec 18 07:16:34 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* mvax.h
 *  MicroVAX hardware data structures 
 */


#ifndef __MVAX_H__
#define __MVAX_H__

#include <vax.h>

#define INT_CLOCK	(0x0c0/4)
#define INT_RSERIAL	(0x2c0/4)
#define INT_WSERIAL	(0x2c4/4)
#define INT_ENET	(0x250/4)
#define INT_ENET2	(0x254/4)
#define INT_VSYNC	(0x244/4)
#define INT_VSYNC2	(0x248/4)
#define INT_TAPE	(0x3f8/4)
#define INT_DISK	(0x3fc/4)


typedef struct {
        ulong   length;
        ulong   errcode;
        ulong   va_reg;
        ulong   int_state;
        ulong   pc;
        ulong   psl;
} MachineCheck;


#define BR50	0
#define BR75	1
#define BR110	2
#define BR134	3
#define BR150	4
#define BR300	5
#define BR600	6
#define BR1200	7
#define BR1800	8
#define BR2000	9
#define BR2400	10
#define BR3600	11
#define BR4800	12
#define BR9600	14
#define BR19200	15

#define PAR_NONE 0x00 
#define PAR_EVEN 0x40
#define PAR_ODD	 0xc0


typedef struct {
        ushort  ser_csr;
	ushort	pad1;
        ushort  ser_lpr;
	ushort	pad2;
        ushort  ser_tcr;
	ushort	pad3;
        ushort  ser_tdr;
	ushort	pad4;
} WSerial;

typedef struct {
        ushort  ser_csr;
	ushort	pad1;
        ushort  ser_rbuf;
	ushort	pad2;
        ushort  ser_tcr;
	ushort	pad3;
        ushort  ser_msr;
	ushort	pad4;
} RSerial;

typedef struct {
        uchar   pad[12];
        uchar   int_msk;
        uchar   pad2[2];
        uchar   int_clr;
} WIntr;

typedef struct {
        uchar   pad[12];
        uchar   int_msk;
        uchar   pad2[2];
        uchar   int_req;
} RIntr;


 
#define  LLBK_2         0x800
#define  DTR_2          0x400
#define  DSRS_2         0x200
#define  RTS_2          0x100

#define  IMASK_SR       0x80
#define  IMASK_ST       0x40
#define  IMASK_NP       0x20
#define  IMASK_NS       0x10
#define  IMASK_VF       0x08
#define  IMASK_VS       0x04
#define  IMASK_SC       0x02
#define  IMASK_DC       0x01


#endif /* __MVAX_H__ */

