/*  srt0.s                                                      (CRC:7f8a70ca)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Wed May 22 21:28:16 1996
 *      header update: Wed Dec 18 07:16:41 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* srt0.s
 *   startup runtime module for kernel
 *   VAX architecture
 */

#define KERNEL
#include <sys/param.h> 
#include <privreg.h> 
#include <mdresource.h> 

.globl	_start
.globl 	_end

.comm	_kstack_data,KSTACK_SIZE
.comm	_istack_data,ISTACK_SIZE

.text
_start:
/* NOTE: when this is first executed, it is located at linear address 0
 * and must be remapped to KERNBASE before Main() is called
 * Therefore all addressing until the remapping must be pc-relative
 * and thus relocatable
 * see the note at the bottom of this file for more info
 */
	nop
	nop
	mtpr    $0x1f,$ R_IPL
        mtpr    $0,$ R_MME                 /* ensure virtual memory is off */
	mtpr	$_kstack_data+KSTACK_SIZE,$ R_KSP
	mtpr	$_istack_data+ISTACK_SIZE,$ R_ISP
        pushl   $0x001f0000
        pushl   $1f
	rei
1:	
	pushl	$0		/* no arguments */
	moval	(sp),ap
	calls	$0,_vm_init	/* initialize virtual memory */
	mtpr	$1,$ R_MME  
	movl	$0,fp
	calls	$0,_Main
	halt	
	halt

#include <udiv.s>
#include <urem.s>
