/*  stubs.s                                                     (CRC:d2d93036)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Wed May 22 21:28:17 1996
 *      header update: Wed Dec 18 07:16:42 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* stubs.s
 *   stubs for VAX kernels
 */

#include <sys/param.h>
#include <event.h>
#include <mdresource.h>
#include <privreg.h>

.globl _clock_set_interval
.globl _interrupt_enable
.globl _ObjCall
.globl _ObjCall_gate
.globl _ObjCall_Trap
.globl _ObjCall_Self
.globl _Label
.globl _Label_gate
.globl _ObjString
.globl _ObjString_gate
.globl _is_kernel
.globl _call_user
.globl _isr_jmp
.globl ___main


#define SYS_ObjCall	0x1000
#define SYS_ObjCallSelf	0x1001
#define SYS_Label	0x1002
#define SYS_ObjString	0x1003
#define SYS_GetPSL	0x1004
#define SYS_KReturn	0x1005	/* return to kernel after user call */


#define IJMP	bsbw _isr; nop; 
#define IJMP4	IJMP IJMP IJMP IJMP
#define IJMP16	IJMP4 IJMP4 IJMP4 IJMP4
#define IJMP64	IJMP16 IJMP16 IJMP16 IJMP16

.align 2
_isr_jmp:		/* nearly all interrupts are vectored here */
/*00*/	IJMP
/*01*/	brw	_isr_mchk; nop		
	IJMP
	IJMP
	IJMP4
/*08*/	bsbw	_isr2; nop		
/*09*/	bsbw	_isr2; nop	
	IJMP
	IJMP
	IJMP
/*0d*/	bsbw	_isr1; nop	
	IJMP
	IJMP
/*10*/	brw	_isr_chmk; nop
	IJMP
	IJMP
	IJMP
	IJMP4
	IJMP4
	IJMP4
/*20*/	IJMP
	IJMP
	IJMP
/*23*/	brw	_isr_dispatch; nop	
	IJMP4
	IJMP4
	IJMP4
/*30*/	IJMP4
	IJMP4
	IJMP4
	IJMP4

/*40*/	IJMP64
/*80*/	IJMP64
/*c0*/	IJMP64

_isr:
	incb	_int_level
	pushr	$0x3f
	pushl	$0		/* errcode */
	pushl	$0		/* va */
	pushl	36(sp)		/* pc */
	subl3	$_isr_jmp+3,36(sp),r0
	pushl	r0		/* ivec */	
	pushl	_int_param(r0)	/* param */
	calls	$5,*_int_vec(r0)
	popr	$0x3f
	addl2	$4,sp
	decb	_int_level
	rei
_isr1:
	incb	_int_level
	pushr	$0x3f
	pushl	28(sp)		/* errcode */
	pushl	$0		/* va */
	pushl	40(sp)		/* pc */
	subl3	$_isr_jmp+3,36(sp),r0
	pushl	r0		/* ivec */
	pushl	_int_param(r0)	/* param */
	calls	$5,*_int_vec(r0)
	popr	$0x3f
	addl2	$8,sp
	decb	_int_level
	rei
_isr2:
	incb	_int_level
	pushr	$0x3f
	pushl	28(sp)		/* errcode */
	pushl	36(sp)		/* va */
	pushl	44(sp)		/* pc */
	subl3	$_isr_jmp+3,36(sp),r0	
	pushl	r0		/* ivec */
	pushl	_int_param(r0)	/* param */
	calls	$5,*_int_vec(r0)
	popr	$0x3f
	addl2	$12,sp
	decb	_int_level
	rei

_isr_mchk:
	halt

_isr_dispatch:
        svpctx
	movl	_thread_context,r0
	mtpr	CONTEXT_PCBB(r0), $ R_PCBB
        ldpctx
        rei


.align 2
_isr_chmk:
	movl	(sp)+,r0
	cmpw	r0,$ SYS_GetPSL
	bneq	1f
	movl	4(sp),r0
	rei
1:	cmpw	r0,$ SYS_ObjCall
	beql	_ObjCall_gate
	cmpw	r0,$ SYS_ObjCallSelf
	beql	_ObjCallSelf_gate
	cmpw	r0,$ SYS_Label
	beql	_Label_gate
	cmpw	r0,$ SYS_ObjString
	beql	_ObjString_gate
	cmpw	r0,$ SYS_KReturn
	bneq	1f
	brw	user_return_trap
1: /* XXX - should panic */
	halt

_ObjCall_gate:
	pushl	16(fp)
	pushl	4(ap)
	pushl	r1
	pushal	4(ap)
	calls	$4,_ObjCall_svc
	rei

_ObjCallSelf_gate:
	pushl	16(fp)
	pushl	24(ap)
	pushl	r1
	pushal	4(ap)
	calls	$4,_ObjCall_svc
	rei

_Label_gate:
	callg	(ap),_Label_svc
	rei	

_ObjString_gate:
	callg	(ap),_ObjString_svc
	ret	

_ObjCall:.word 0x0
	movl	$0,r1
	chmk	$ SYS_ObjCall
	ret

_ObjCall_Trap:.word 0x0	
	movl	$1,r1
	chmk	$ SYS_ObjCall
	ret

_ObjCall_Self:.word 0x0
	movl	$0,r1
	chmk	$ SYS_ObjCallSelf
	ret

_Label:.word 0x0
	chmk	$ SYS_Label
	ret

_ObjString:.word 0x0
	chmk	$ SYS_ObjString
	ret

_is_kernel:.word 0x0
	chmk	$ SYS_GetPSL
	bicl2	$0xf0ffffff,r0
	tstl	r0
	bneq	1f
	movl	$1,r0
	ret
1:	clrl	r0
	ret

_call_user:.word 0x0
	mfpr	$ R_USP, r0
	movl	24(ap),-(r0)
	movl	20(ap),-(r0)
	movl	16(ap),-(r0)
	movl	12(ap),-(r0)
	movl	8(ap),-(r0)
	mtpr	r0, $ R_USP
	movl	4(ap),r0
	pushl	$0x03c00000
	pushal	1f
	rei
1:	calls	$5,(r0)
user_return:
	chmk	$ SYS_KReturn
user_return_trap:
	cmpl	(sp),$ user_return_trap
	bneq	1f
	addl2	$8,sp
	ret
1:	rei

_interrupt_enable:.word 0x0
	mtpr	$ IPL_MIN, $ R_IPL
	ret


___main:.word 0x0
	ret

