/*  getty.c                                                     (CRC:801ee1f9)
 *      standard login
 *
 *      relative path: ./drv
 *      creation date: 1992
 *      last modified: Thu Dec 19 23:28:36 1996
 *      header update: Fri Dec 20 09:09:06 1996
 *  
 *       Device drivers
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */


#include <sys/types.h>
#include <sys/resource.h>
#include <stdio.h>
#include <error.h>
#include <event.h>
#include <dir.h>



extern label_t _stdin, _stdout, _stderr;
extern label_t _icrnl, _onlcr, _name, _echo, _echonl;
extern label_t _msleep, _exec, _wait;



obj_t Main(ObjFrame *frame, vaddr base, obj_t arg, obj_t env)
{
char buf[50];
char pw[50];
int n, pos;
obj_t fd, td;
	buf[0] = '\0';
	while(1) {
		if(!buf[0])
			printf("\n\nShag/OS Classic 0.37 (Rev. 1) (fugazi)\n\n");
		printf("login: ");
		if(!getstrn(buf,sizeof(buf)))
			return(OK);
		if(!buf[0])
			continue;
		if(buf[0]) {
			_(OBJ_STDIN, _set, _echo, OBJ_FALSE, ___);
			_(OBJ_STDIN, _set, _echonl, OBJ_TRUE, ___);
			printf("Password: ");
			getstrn(pw,sizeof(pw));
			_(OBJ_STDIN, _set, _echo, OBJ_TRUE, ___);
			_(OBJ_STDIN, _set, _echonl, OBJ_FALSE, ___);
			if(!pw[0])
				break;
			printf("Login incorrect\n");
		}
	}
	fd = dir_parse(OBJ_ROOT,"/etc/motd");
	pos = 0;
	while((n=err_(fd,_readat,Ptr(buf),sizeof(buf),pos)) > 0) {
		_(OBJ_STDOUT,_write,Ptr(buf),n,___);
		pos += n;
	}
	_(OBJ_THREAD,_set,_name,Label("osh"),___);
	fd = dir_parse(OBJ_ROOT,"/bin/osh");
	td = _(OBJ_TASK, _new, ___, ___, ___);	
	fd = _(td, _exec, fd, ___, ___);
	_(td, _free, ___, ___, ___);
	if(err(fd))
		print_error("osh", fd);
	else
		printf("logout\n");
	return(OK);
}

