/*  param.h                                                     (CRC:feebede1)
 *      relative path: ./include/sys
 *      creation date: 1992
 *      last modified: Sat Dec 14 10:33:41 1996
 *      header update: Wed Dec 18 07:17:40 1996
 *  
 *       Include files
 *        System Include files
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __PARAM_H__
#define __PARAM_H__

#define VER_MAJOR 0
#define VER_MINOR 37

#define K	1024
#define MEG	K*K
#define GIG	K*MEG

#include <mdparam.h>


#define CHAR_BB_SIZE	64	/* character buffer block size--
				   how many chars (4 used for link) to
				   put in each character bucket -
				   must be a power of two  */

#define MAXBUFSIZE	11*K	/* maximum size any character/event buffer
				   can grow to before the thread is 
				   put to sleep */

#define NBUFDESC	4	/* number of buffer descriptors per thread */

#define HZ		(clock_get_hz())

#define MAXQUANTUM	(HZ/2)	/* maximum number of clock ticks */
#define MINQUANTUM	4	/* minumum number of clock ticks */
#define QUANTUM_WAIT	(HZ/5)	/* adjustment for event waits */
#define QUANTUM_SLEEP	(HZ/4)	/* adjustment for sleeping */
#define QUANTUM_CPUBOUND (HZ/5)	/* -adjustment for CPU-bound process */

#define SYSTIME_EPOCH	1992
#define POSIX_EPOCH	1970

#define MAXLABEL	32	/* maximum length of an indentifer label */

#endif /* __PARAM_H__ */

