/*  $Id: types.h,v 1.1 1996/12/08 15:06:00 shaggy Exp shaggy $
 *      data type definitions
 *      relative path: ./include/sys
 *  
 *       Include files
 *        System Include files
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: types.h,v $
 *  Revision 1.1  1996/12/08  15:06:00  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */

#ifndef __TYPES_H__
#define __TYPES_H__


#ifndef ASM

typedef unsigned char	uchar;
typedef unsigned short	ushort;
typedef unsigned long	ulong;
typedef unsigned int	uint;
typedef unsigned char	boolean;
typedef void		(*void_fptr)(void);
typedef int		(*int_fptr)(void);
typedef char		*(*str_fptr)(void);
typedef int		(*main_fptr)(int argc, char **argv);
typedef unsigned long	vaddr;
typedef unsigned long	paddr;
typedef unsigned char	lock_t;
typedef	ulong		obj_t;
typedef ulong		status_t;
typedef obj_t		label_t;

/* POSIX types: */

typedef ushort		wchar_t;

typedef ushort		dev_t;
typedef ulong		ino_t;
typedef ushort		mode_t;
typedef ushort		nlink_t;
typedef long		off_t;
typedef ulong		pid_t;
typedef ushort		uid_t;
typedef ushort		gid_t;

typedef long		time_t;
typedef	long		clock_t;


#ifndef _SIZE_T
#define _SIZE_T
typedef uint		size_t;
#endif

#ifndef _SSIZE_T
#define _SSIZE_T
typedef long		ssize_t;
#endif

#ifndef _PTRDIFF_T
#define _PTRDIFF_T
typedef long int	ptrdiff_t;
#endif


#endif


#endif /* __TYPES_H__ */

