/*  vt100.h                                                     (CRC:3d0df063)
 *      relative path: ./include/sys
 *      creation date: 1992
 *      last modified: Wed May 22 21:41:17 1996
 *      header update: Wed Dec 18 07:17:39 1996
 *  
 *       Include files
 *        System Include files
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __VT100_H__
#define __VT100_H__


#define VT_MAXPARAM 8	/* maximum number of arguments */

struct vt_state {
/* used by implementation: */
	ushort	*base;
	ushort	atval;
	int	id;
/* used by VT emulator: */
	short	wid;
	short	hgt;
	short	xpos;
	short	ypos;
	short	y1;
	short	y2;
	ushort	mode;	/* misc mode parameters */
	ushort	qmode;	/* extended mode parameters */
	ushort	attr;	/* display attributes */
	uchar	fg;	/* foreground color */
	uchar	bg;	/* background color */
/* saved values */
	short	save_xpos;
	short	save_ypos;
	short	save_y1;
	short	save_y2;
	ushort	save_attr;
	uchar	save_fg;
	uchar	save_bg;
/* escape code parsing; */
	uchar	esc;		/* escape mode */
	uchar	pcount;		/* parameter count */
	uchar	type;		/* escape code type */
	char	ptype;		/* current parameter type */
	short	value;		/* current value */
	short	param[VT_MAXPARAM];	/* args */
};



static void vt_write(struct vt_state *vt, uchar *adr, int len);
static void vt_init(struct vt_state *vt);


#endif /* __VT100_H__ */

