/*  fstdio.c                                                    (CRC:c5f5c3c1)
 *      relative path: ./posix
 *      creation date: 1992
 *      last modified: Wed May 22 21:36:22 1996
 *      header update: Wed Dec 18 07:17:56 1996
 *  
 *       POSIX standard library
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  fstdio.c
 *    standard File I/O routines 
 */


#include <sys/types.h>
#include <sys/resource.h>
#include <stdio.h>
#include <error.h>
#include <string.h>
#include <stdarg.h>



int fclose(FILE *stream)
{
	printf("fclose\n");
	return(0);
}

FILE *fdopen(int fildes, const char *type)
{
	printf("fdopen\n");
	return(NULLP(FILE));
}

int feof(FILE *stream)
{
	printf("fdopen\n");
	return(0);
}

int ferror(FILE *stream)
{
	printf("ferror\n");
	return(0);
}

int fflush(FILE *stream)
{
	printf("fflush\n");
	return(0);
}

int fgetc(FILE *stream)
{
	printf("fgetc\n");
	return(0);
}

int fgetpos(FILE *stream, fpos_t *pos)
{
	printf("fgetpos\n");
	return(0);
}

char *fgets(char *s, int n, FILE *stream)
{
	printf("fgets\n");
	return((char*)0);
}


int fileno(FILE *stream)
{
	printf("fileno\n");
	return(0);
}

FILE *fopen(const char *filename, const char *mode)
{
	printf("fopen %s,%s\n", filename, mode);
	return(0);
}

int fprintf(FILE *stream, const char *fmt, ...)
{
	printf("fprintf\n");
	return(0);
}

int putc(int c, FILE *stream)
{
	printf("putc\n");
	return(0);
}

int fputc(int c, FILE *stream)
{
	printf("fputc\n");
	return(0);
}

int fputs(const char *s, FILE *stream)
{
	printf("fputs\n");
	return(0);
}

size_t fread(void *ptr, size_t size, size_t nelem, FILE *stream)
{
	printf("fread\n");
	return(0);
}

FILE *freopen(const char *filename, const char *mode, FILE *stream)
{
	printf("freopen\n");
	return(NULLP(FILE));
}

int fscanf(FILE *stream, const char *format, ...)
{
	printf("fscanf\n");
	return(0);
}

int fseek(FILE *stream, long offset, int whence)
{
	printf("fseek\n");
	return(0);
}

int fsetpos(FILE *stream, const fpos_t *pos)
{
	printf("fsetpos\n");
	return(0);
}

long ftell(FILE *stream)
{
	printf("ftell\n");
	return(0);
}

size_t fwrite(const void *ptr, size_t size, size_t nelem, FILE *stream)
{
	printf("fwrite\n");
	return(0);
}

