/*  ls.c                                                        (CRC:a252ca77)
 *      relative path: ./usr
 *      creation date: 1992
 *      last modified: Wed May 22 21:39:45 1996
 *      header update: Wed Dec 18 07:18:29 1996
 *  
 *       User-level programs
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* ls.c
 *   file utilities
 */

#include <sys/types.h>
#include <stdio.h>
#include <object.h>
#include <error.h>


extern label_t _dir, _size;
 
#ifdef XXX
main(argc,argv)
int argc;
char **argv;
{
char buf[80];
obj_t wd;
	_dir = Label("dir");
	_size = Label("size");
	wd = _(OBJ_ROOT,_get,Label("func")); 
	dir_parse = (obj_fptr)_(wd,_get,Label("dir_parse"));
	dir_parse_path = (obj_fptr)_(wd,_get,Label("dir_parse_path"));
	ObjString = (str_fptr)_(wd,_get,Label("ObjString"));
	dir_parse_path(OBJ_CWD,argv[0],buf,FALSE);
	if(!strcmp(buf,"ls"))
		return(kls(argc,argv));
	else if(!strcmp(buf,"mv"))
		return(kmv(argv,argv));
	else if(!strcmp(buf,"ln"))
		return(kln(argv,argv));
	else if(!strcmp(buf,"cp"))
		return(kcp(argv,argv));
	else if(!strcmp(buf,"rm"))
		return(kcp(argv,argv));
	else if(!strcmp(buf,"mkdir"))
		return(kcp(argv,argv));
	return(ERR_NOMETHOD);
}
#endif
