/*  $Id: bin_comp.c,v 1.2 1996/12/20 14:10:30 shaggy Exp $
 *      binary compiler to assemble binary data into an object file
 *      relative path: ./util
 *  
 *       Utilities
 *  
 *  Copyright (C) 1992  Frank E. Barrus
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: bin_comp.c,v $
 *  Revision 1.2  1996/12/20  14:10:30  shaggy
 *  header update
 *
 *  Revision 1.1  1996/12/18  03:39:36  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */

#include <stdio.h>
#include <a.out.h>


char buf[262144];


main(argc,argv)
int argc;
char **argv;
{
FILE *f1, *f2;
struct exec exec;
struct nlist nlist;
int n, tsize;
char name[100];
char strtable[4096];
char *cp;
struct nlist symtable[256];
int nsyms;
int i;
int v;
char *p;
	if (argc < 4) {
		printf("usage: %s <input> <output> <symbol>...\n",argv[0]);
		exit(1);
	}
	f1 = fopen(argv[1], "r");	
	if(!f1) {
		perror(argv[1]);
		exit(1);
	}
	f2 = fopen(argv[2], "w");
	if(!f2) {
		perror(argv[2]);
		exit(1);
	}
	if((n=fread(buf,1,262144,f1)) < 0) {
		printf("error reading data\n");
		exit(1);
	}
	cp = strtable+4;
	i = 3;
	nsyms = 0;
	while(i < argc) {
		symtable[nsyms].n_un.n_strx = (cp-strtable);
		symtable[nsyms].n_type = N_DATA | N_EXT;
		symtable[nsyms].n_other = 0;
		symtable[nsyms].n_desc = 0;
		strcpy(name,argv[i]);
		v = 0;
		if(p = (char*)strchr(name,':')) {
			v = atoi(p+1);
			*p = '\0';
		}	
		symtable[nsyms].n_value = v;
#ifndef __ELF__
		*cp++ = '_';	/* underscore prefix for a.out format */
#endif
		strcpy(cp,name);
		cp += (strlen(cp)+1);
		nsyms++;
		i++;
	}
	n = ((n-1)/4+1)*4;
	printf("size=%d,%d nsyms=%d\n",n,tsize,nsyms);
	tsize = ((n-1)/1024+1)*1024;
#ifdef I386
	exec.a_info = OMAGIC;
#else
	exec.a_magic = OMAGIC;
#endif
/*
	exec.a_magic = 0x107;
	exec.a_mode = 0;
*/
	exec.a_text = 0;
	exec.a_data = n;
	exec.a_bss = 0;
	exec.a_syms = nsyms*sizeof(struct nlist);
	exec.a_entry = 0;
	exec.a_trsize = 0;
	exec.a_drsize = 0;
	*(long*)strtable  = cp-strtable;
	fwrite(&exec,sizeof(exec),1,f2);
	fwrite(buf,1,n,f2);
	fwrite(symtable,sizeof(struct nlist),nsyms,f2);
	fwrite(strtable,1,cp-strtable,f2);
	fclose(f1);
	fclose(f2);
}

