/*  fsbuild.c                                                   (CRC:e0c45d69)
 *      relative path: ./util
 *      creation date: 1992
 *      last modified: Wed May 22 21:40:25 1996
 *      header update: Wed Dec 18 07:18:41 1996
 *  
 *       Utilities
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* fsbuild.c
 *   builds a static filesystem
 *   
 *   yes, this is a really quick and cheesy hack,
 *   but it works, and it's not part of the kernel,
 *   so I don't care
 */

#define KERNEL
#include <sys/types.h>
#include <sys/resource.h>
#define _SIZE_T
#define _SIZE_T_
#undef NULL
#include "/usr/include/stdio.h"

main(argc,argv)
int argc;
char **argv;
{
FILE *f1, *f2;
int n, x, i;
char *buf, *bp;
StaticFS fsnode[256];
ulong size;
ulong nentries;
char str[256];
char spath[256], dpath[256];
	if(argc  != 3) {
		printf("usage: %s <sfs_file> <sfs_list>\n");
		exit(1);
	}
	f1 = fopen(argv[2], "r");
	n = 0;
	buf = (char*)malloc(2*1024*1024);
	bp = buf;
	while(fgets(str,sizeof(str),f1)) {
		if(!str[0] || str[0] == '\n' || str[0] == '#')
			continue;
		i = sscanf(str,"%s %s",spath,dpath);
		if(!i)
			continue;
		if(i < 2)
			strcpy(dpath,spath);
		fsnode[n].name = bp;
		strcpy(bp, dpath);
		bp += (strlen(dpath)+1);
		f2 = fopen(spath, "r");
		if(!f2) {
			perror(spath);
			exit(1);
		}
		fsnode[n].size = fread(bp, 1, 262144, f2);
		fsnode[n].data = bp;
		fsnode[n].ofs = 0;
		bp += fsnode[n].size;
		printf("%d: %s -> %s: %d bytes\n", n, spath, dpath, fsnode[n].size);
		fclose(f2);
		n++;
	}
	for(i=0; i<n; i++) {
		fsnode[i].name += ((char*)(sizeof(StaticFS)*n)-buf);
		fsnode[i].data += ((char*)(sizeof(StaticFS)*n)-buf);
	}
	fclose(f1);
	f1 = fopen(argv[1], "w");
	size = bp-buf+(sizeof(StaticFS)*n);
	nentries = n;
	fwrite(&size,sizeof(ulong),1,f1);
	fwrite(&nentries,sizeof(ulong),1,f1);
	fwrite(fsnode,sizeof(StaticFS),n,f1);
	fwrite(buf,1,bp-buf,f1);
	fclose(f1);
}

