/*  $Id: makedepend.c,v 1.1 1996/12/19 16:37:32 shaggy Exp shaggy $
 *  takes dependencies list generated by 'cc' or 'gcc'
 *  and generates dependencies and rules for Makefile
 *  and tacks them onto the end
 *  expects to be called with: dependlist Makefile.bak
 *
 *      relative path: ./util
 *  
 *       Utilities
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: makedepend.c,v $
 *  Revision 1.1  1996/12/19  16:37:32  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */


#include <stdio.h>


main(argc,argv)
int argc;
char **argv;
{
FILE *df;
FILE *inf;
char str[4096];	
char *buf;
char *bp;
char *sp;
char obj[256];
char src[256];
char lastobj[256];
int n;
char *prefix = "";
	if(!strcmp(argv[1], "-p")) {
		prefix = argv[2];
		argc -= 2;
		argv[2] = argv[0];	
		argv += 2;
	}
	if(argc < 3) {
		fprintf(stderr, "usage: %s [-p prefix] <dependfile> <old_makefile>\n",
				argv[0]);
		exit(1);
	}
	if (!(df = fopen(argv[1], "r"))) {
		perror(argv[1]);	
		exit(1);
	}
	if (!(inf = fopen(argv[2], "r"))) {
		perror(argv[2]);
		exit(1);
	}
	while(fgets(str, 4095, inf)) {
		fputs(str, stdout);
		if(!strncmp(str,"#DO NOT DELETE THIS LINE", 25))
			break;
	}
	fclose(inf);	
	buf = (char*)malloc(65536);
	bp = buf;
	strcpy(lastobj, "");
	while(fgets(str, 4095, df)) {
		sp = str;
		while(*sp) {
			*bp++ = *sp++;	
		}
		sp--;	
		bp--;
		if(*(--sp) == '\\') {
			bp--;
			continue;
		}
		*bp = '\0';
		sp = buf;
		bp = obj;
		while(*sp > 32 && *sp != ':')
			*bp++ = *sp++;
		*bp = '\0';	
		while(*sp++ != ':')
			continue;
		sscanf(sp, "%s", src);
		while(*sp) {
			n = printf("%s: ", obj);
			if(strlen(sp) > 78-n) {
				bp = sp + (78-n);
				while(*bp > 32)
					bp--;
				*bp = '\0';
				printf("%s\n", sp);	
				sp = bp+1;
			} else {
				printf("%s\n", sp);
				break;
			}
		}
		if (strcmp(lastobj, obj)) {
			if(!strncmp(src+(strlen(src)-2), ".c", 2))
				printf("\t${%sCC} ${%sCFLAGS} -c %s\n", prefix, prefix, src);
			else if(!strncmp(src+(strlen(src)-2), ".s", 2)) {
				printf(
"\t${%sCPP} ${%sINCLUDE} ${%sDEFINE} -DASM %s >TEMP.s\n", prefix, prefix, prefix, src);
				printf("\t${%sAS} -o %s TEMP.s\n", prefix, obj);	
			}
		}
		strcpy(lastobj, obj);
		bp = buf;
	}	
	fclose(df);	
}
