/*  makelabels.c                                                (CRC:6b8cf032)
 *      relative path: ./util
 *      creation date: 1992
 *      last modified: Wed May 22 21:40:32 1996
 *      header update: Wed Dec 18 07:18:45 1996
 *  
 *       Utilities
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* makelabels.c
 */

#include <stdio.h>


main(argc,argv)
int argc;
char **argv;
{
FILE *f1,*f2;
char label[80];
int x;
	if(argc != 3) {
		printf("usage: makelabels <namelist> <dest.c>\r\n");
		exit(1);
	}
	f2 = fopen(argv[2],"w");
	fprintf(f2,"/* %s\n",argv[2]);
        fprintf(f2," * initializes labels\n");
	fprintf(f2," * - this code was written by 'makelabels'\n");
	fprintf(f2," */\n");
	fprintf(f2,"#include <sys/types.h>\n");
	fprintf(f2,"#include <object.h>\n");
	fprintf(f2,"#include <sys/label.h>\n");
	fprintf(f2,"#include <stddef.h>\n\n\n");
	f1 = fopen(argv[1],"r");
	x = 0;
	while(!feof(f1)) {
		fscanf(f1,"%s",label);
		if(label[0]=='_' && label[1]=='_' && label[2]!='_') {
			if(x+strlen(label+1) > 70) {
				fprintf(f2,";\n");
				x = 0;
			}	
			if(x==0) {
				fprintf(f2,"label_t ");
				x = 4;
			} else {
				fprintf(f2,", ");
				x += 2;
			}
			fprintf(f2,"%s=0",label+1);
			x += strlen(label+1);
		}
	}
	fclose(f1);
	fprintf(f2,";\n\n\n");
	fprintf(f2,"struct init_label label_init[] = {\n");
	f1 = fopen(argv[1],"r");
	while(!feof(f1)) {
		fscanf(f1,"%s",label);
		if(label[0]=='_' && label[1]=='_' && label[2]!='_') 
			fprintf(f2,"{\"%s\", (label_t)&%s},\n",label+2,label+1);
	}
	fprintf(f2,"};\n\n");
	fprintf(f2,"int label_init_size = arraysize(label_init);\n");
	fclose(f2);
}

