/*  setmagic.c                                                  (CRC:2eac04a9)
 *      relative path: ./util
 *      creation date: 1992
 *      last modified: Wed May 22 21:40:58 1996
 *      header update: Wed Dec 18 07:18:46 1996
 *  
 *       Utilities
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* setmagic.c
 *   sets the magic number on a file
 */

#include <sys/types.h>
#include <sys/exec.h>
#include <stdio.h>

int main(int argc, char **argv)
{
struct exec header;
FILE *f;
ushort magic;
	f = fopen(argv[2],"r+");
	if(!strcmp(argv[1],"OMAGIC"))
		magic = OMAGIC;
	else if(!strcmp(argv[1],"NMAGIC"))
		magic = NMAGIC;
	else if(!strcmp(argv[1],"ZMAGIC"))
		magic = ZMAGIC;
	else if(!strcmp(argv[1],"LMAGIC"))
		magic = LMAGIC;
	else if(!strcmp(argv[1],"QMAGIC"))
		magic = QMAGIC;
	else
		magic = strtol(argv[1],0,8);
	fread(&header,sizeof(header),1,f);
	header.a_magic = magic;
	fseek(f,0,SEEK_SET);
	fwrite(&header,sizeof(header),1,f);
	fclose(f);
	return(0);
}

